function [v,beta,sigma]=house2(x,k,y)
%%[v,beta]=house2(a) return the vector for the householder matrix
%%H=I-2*beta*v*v' such that H*x= y. By defalt(if the nargin is 1) that is
%%y= sigma *e_1 for some scalar sigma. 
% optional parmater is choose the sign of sigma, by default 
%  k=0  sigma= -sign(x_1) norm(x,2). the diagonal of R can be +/-
%  k=1  sigma = norm(x,2);    the diagonal of R is positive 
%  k=2  sigma = -norm(x,2)    the digonal of R is negative 
%
%  by Shengxin.Zhu@bnu.edu.cn
% 
% Reference：Nick Higham Accurancy and Stability of Numerical Algorithms 2nd
if nargin==0
    x=ones(5,1)  +j*ones(5,1)
    [v,beta]=house2(x,1)
    H=eye(5)-beta*v*v'
    y=H*x
    return 
end

y=zeros(size(x));
if nargin==1
    k=0;
end
if nargin <=2
    if k==0
        sigma = -sign(x(1))*norm(x,2);
%         sigma = norm(x,2);
    end
    if k==1
        sigma = norm(x,2);
    end
    if k==2
        sigma = -norm(x,2);
    end
    v=x;
    v(1)=v(1)-sigma;
    beta=-1/(sigma*(real(v(1))));
end 

